var THREE$RGBA_PVRTC_2BPPV1_Format;
var THREE$RGBA_PVRTC_4BPPV1_Format;
var THREE$RGB_PVRTC_2BPPV1_Format;
var THREE$RGB_PVRTC_4BPPV1_Format;
var THREE$RGBA_S3TC_DXT5_Format;
var THREE$RGBA_S3TC_DXT3_Format;
var THREE$RGBA_S3TC_DXT1_Format;
var THREE$RGB_S3TC_DXT1_Format;
var THREE$RGBEFormat;
var THREE$LuminanceAlphaFormat;
var THREE$LuminanceFormat;
var THREE$RGBAFormat;
var THREE$RGBFormat;
var THREE$AlphaFormat;
var THREE$UnsignedShort565Type;
var THREE$UnsignedShort5551Type;
var THREE$UnsignedShort4444Type;
var THREE$HalfFloatType;
var THREE$FloatType;
var THREE$UnsignedIntType;
var THREE$IntType;
var THREE$UnsignedShortType;
var THREE$ShortType;
var THREE$ByteType;
var THREE$UnsignedByteType;
var THREE$LinearMipMapLinearFilter;
var THREE$LinearMipMapNearestFilter;
var THREE$LinearFilter;
var THREE$NearestMipMapLinearFilter;
var THREE$NearestMipMapNearestFilter;
var THREE$NearestFilter;
var THREE$MirroredRepeatWrapping;
var THREE$ClampToEdgeWrapping;
var THREE$RepeatWrapping;
var THREE$SphericalReflectionMapping;
var THREE$EquirectangularRefractionMapping;
var THREE$EquirectangularReflectionMapping;
var THREE$CubeRefractionMapping;
var THREE$CubeReflectionMapping;
var THREE$UVMapping;
var THREE$AddOperation;
var THREE$MixOperation;
var THREE$MultiplyOperation;
var THREE$NotEqualDepth;
var THREE$GreaterDepth;
var THREE$GreaterEqualDepth;
var THREE$EqualDepth;
var THREE$LessEqualDepth;
var THREE$LessDepth;
var THREE$AlwaysDepth;
var THREE$NeverDepth;
var THREE$SrcAlphaSaturateFactor;
var THREE$OneMinusDstColorFactor;
var THREE$DstColorFactor;
var THREE$OneMinusDstAlphaFactor;
var THREE$DstAlphaFactor;
var THREE$OneMinusSrcAlphaFactor;
var THREE$SrcAlphaFactor;
var THREE$OneMinusSrcColorFactor;
var THREE$SrcColorFactor;
var THREE$OneFactor;
var THREE$ZeroFactor;
var THREE$MaxEquation;
var THREE$MinEquation;
var THREE$ReverseSubtractEquation;
var THREE$SubtractEquation;
var THREE$AddEquation;
var THREE$CustomBlending;
var THREE$MultiplyBlending;
var THREE$SubtractiveBlending;
var THREE$AdditiveBlending;
var THREE$NormalBlending;
var THREE$NoBlending;
var THREE$VertexColors;
var THREE$FaceColors;
var THREE$NoColors;
var THREE$SmoothShading;
var THREE$FlatShading;
var THREE$NoShading;
var THREE$DoubleSide;
var THREE$BackSide;
var THREE$FrontSide;
var THREE$PCFSoftShadowMap;
var THREE$PCFShadowMap;
var THREE$BasicShadowMap;
var THREE$FrontFaceDirectionCCW;
var THREE$FrontFaceDirectionCW;
var THREE$CullFaceFrontBack;
var THREE$CullFaceFront;
var THREE$CullFaceBack;
var THREE$CullFaceNone;
var THREE$MOUSE;

/**
 * @author mrdoob / http://mrdoob.com/
 */

var THREE = { REVISION: '72dev' };

// browserify support

if ( typeof module === 'object' ) {

	module.exports = THREE;

}

// polyfills

if ( Math.sign === undefined ) {

	// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/sign

	Math.sign = function ( x ) {

		return ( x < 0 ) ? - 1 : ( x > 0 ) ? 1 : +x;

	};

}

if ( Function.prototype.name === undefined && Object.defineProperty !== undefined ) {

	// Missing in IE9-11.
	// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/name

	Object.defineProperty( Function.prototype, 'name', {

		get: function () {

			return this.toString().match(/^\s*function\s*(\S*)\s*\(/)[1];

		}

	} );

}

// https://developer.mozilla.org/en-US/docs/Web/API/MouseEvent.button

THREE$MOUSE = { LEFT: 0, MIDDLE: 1, RIGHT: 2 };

// GL STATE CONSTANTS

THREE$CullFaceNone = 0;
THREE$CullFaceBack = 1;
THREE$CullFaceFront = 2;
THREE$CullFaceFrontBack = 3;

THREE$FrontFaceDirectionCW = 0;
THREE$FrontFaceDirectionCCW = 1;

// SHADOWING TYPES

THREE$BasicShadowMap = 0;
THREE$PCFShadowMap = 1;
THREE$PCFSoftShadowMap = 2;

// MATERIAL CONSTANTS

// side

THREE$FrontSide = 0;
THREE$BackSide = 1;
THREE$DoubleSide = 2;

// shading

THREE$NoShading = 0;
THREE$FlatShading = 1;
THREE$SmoothShading = 2;

// colors

THREE$NoColors = 0;
THREE$FaceColors = 1;
THREE$VertexColors = 2;

// blending modes

THREE$NoBlending = 0;
THREE$NormalBlending = 1;
THREE$AdditiveBlending = 2;
THREE$SubtractiveBlending = 3;
THREE$MultiplyBlending = 4;
THREE$CustomBlending = 5;

// custom blending equations
// (numbers start from 100 not to clash with other
//  mappings to OpenGL constants defined in Texture.js)

THREE$AddEquation = 100;
THREE$SubtractEquation = 101;
THREE$ReverseSubtractEquation = 102;
THREE$MinEquation = 103;
THREE$MaxEquation = 104;

// custom blending destination factors

THREE$ZeroFactor = 200;
THREE$OneFactor = 201;
THREE$SrcColorFactor = 202;
THREE$OneMinusSrcColorFactor = 203;
THREE$SrcAlphaFactor = 204;
THREE$OneMinusSrcAlphaFactor = 205;
THREE$DstAlphaFactor = 206;
THREE$OneMinusDstAlphaFactor = 207;

// custom blending source factors

//THREE.ZeroFactor = 200;
//THREE.OneFactor = 201;
//THREE.SrcAlphaFactor = 204;
//THREE.OneMinusSrcAlphaFactor = 205;
//THREE.DstAlphaFactor = 206;
//THREE.OneMinusDstAlphaFactor = 207;
THREE$DstColorFactor = 208;
THREE$OneMinusDstColorFactor = 209;
THREE$SrcAlphaSaturateFactor = 210;

// depth modes

THREE$NeverDepth = 0;
THREE$AlwaysDepth = 1;
THREE$LessDepth = 2;
THREE$LessEqualDepth = 3;
THREE$EqualDepth = 4;
THREE$GreaterEqualDepth = 5;
THREE$GreaterDepth = 6;
THREE$NotEqualDepth = 7;


// TEXTURE CONSTANTS

THREE$MultiplyOperation = 0;
THREE$MixOperation = 1;
THREE$AddOperation = 2;

// Mapping modes

THREE$UVMapping = 300;

THREE$CubeReflectionMapping = 301;
THREE$CubeRefractionMapping = 302;

THREE$EquirectangularReflectionMapping = 303;
THREE$EquirectangularRefractionMapping = 304;

THREE$SphericalReflectionMapping = 305;

// Wrapping modes

THREE$RepeatWrapping = 1000;
THREE$ClampToEdgeWrapping = 1001;
THREE$MirroredRepeatWrapping = 1002;

// Filters

THREE$NearestFilter = 1003;
THREE$NearestMipMapNearestFilter = 1004;
THREE$NearestMipMapLinearFilter = 1005;
THREE$LinearFilter = 1006;
THREE$LinearMipMapNearestFilter = 1007;
THREE$LinearMipMapLinearFilter = 1008;

// Data types

THREE$UnsignedByteType = 1009;
THREE$ByteType = 1010;
THREE$ShortType = 1011;
THREE$UnsignedShortType = 1012;
THREE$IntType = 1013;
THREE$UnsignedIntType = 1014;
THREE$FloatType = 1015;
THREE$HalfFloatType = 1025;

// Pixel types

//THREE.UnsignedByteType = 1009;
THREE$UnsignedShort4444Type = 1016;
THREE$UnsignedShort5551Type = 1017;
THREE$UnsignedShort565Type = 1018;

// Pixel formats

THREE$AlphaFormat = 1019;
THREE$RGBFormat = 1020;
THREE$RGBAFormat = 1021;
THREE$LuminanceFormat = 1022;
THREE$LuminanceAlphaFormat = 1023;
// THREE.RGBEFormat handled as THREE.RGBAFormat in shaders
THREE$RGBEFormat = THREE$RGBAFormat; //1024;

// DDS / ST3C Compressed texture formats

THREE$RGB_S3TC_DXT1_Format = 2001;
THREE$RGBA_S3TC_DXT1_Format = 2002;
THREE$RGBA_S3TC_DXT3_Format = 2003;
THREE$RGBA_S3TC_DXT5_Format = 2004;


// PVRTC compressed texture formats

THREE$RGB_PVRTC_4BPPV1_Format = 2100;
THREE$RGB_PVRTC_2BPPV1_Format = 2101;
THREE$RGBA_PVRTC_4BPPV1_Format = 2102;
THREE$RGBA_PVRTC_2BPPV1_Format = 2103;


// DEPRECATED

function THREE$Projector () {
	this.isProjector = true;

	console.error( 'THREE.Projector has been moved to /examples/js/renderers/Projector.js.' );

	this.projectVector = function ( vector, camera ) {

		console.warn( 'THREE.Projector: .projectVector() is now vector.project().' );
		vector.project( camera );

	};

	this.unprojectVector = function ( vector, camera ) {

		console.warn( 'THREE.Projector: .unprojectVector() is now vector.unproject().' );
		vector.unproject( camera );

	};

	this.pickingRay = function ( vector, camera ) {

		console.error( 'THREE.Projector: .pickingRay() is now raycaster.setFromCamera().' );

	};

};

function THREE$CanvasRenderer () {
	this.isCanvasRenderer = true;

	console.error( 'THREE.CanvasRenderer has been moved to /examples/js/renderers/CanvasRenderer.js' );

	this.domElement = document.createElement( 'canvas' );
	this.clear = function () {};
	this.render = function () {};
	this.setClearColor = function () {};
	this.setSize = function () {};

};


export {
  THREE$CanvasRenderer,
  THREE$Projector,
  THREE$RGBA_PVRTC_2BPPV1_Format,
  THREE$RGBA_PVRTC_4BPPV1_Format,
  THREE$RGB_PVRTC_2BPPV1_Format,
  THREE$RGB_PVRTC_4BPPV1_Format,
  THREE$RGBA_S3TC_DXT5_Format,
  THREE$RGBA_S3TC_DXT3_Format,
  THREE$RGBA_S3TC_DXT1_Format,
  THREE$RGB_S3TC_DXT1_Format,
  THREE$RGBEFormat,
  THREE$LuminanceAlphaFormat,
  THREE$LuminanceFormat,
  THREE$RGBAFormat,
  THREE$RGBFormat,
  THREE$AlphaFormat,
  THREE$UnsignedShort565Type,
  THREE$UnsignedShort5551Type,
  THREE$UnsignedShort4444Type,
  THREE$HalfFloatType,
  THREE$FloatType,
  THREE$UnsignedIntType,
  THREE$IntType,
  THREE$UnsignedShortType,
  THREE$ShortType,
  THREE$ByteType,
  THREE$UnsignedByteType,
  THREE$LinearMipMapLinearFilter,
  THREE$LinearMipMapNearestFilter,
  THREE$LinearFilter,
  THREE$NearestMipMapLinearFilter,
  THREE$NearestMipMapNearestFilter,
  THREE$NearestFilter,
  THREE$MirroredRepeatWrapping,
  THREE$ClampToEdgeWrapping,
  THREE$RepeatWrapping,
  THREE$SphericalReflectionMapping,
  THREE$EquirectangularRefractionMapping,
  THREE$EquirectangularReflectionMapping,
  THREE$CubeRefractionMapping,
  THREE$CubeReflectionMapping,
  THREE$UVMapping,
  THREE$AddOperation,
  THREE$MixOperation,
  THREE$MultiplyOperation,
  THREE$NotEqualDepth,
  THREE$GreaterDepth,
  THREE$GreaterEqualDepth,
  THREE$EqualDepth,
  THREE$LessEqualDepth,
  THREE$LessDepth,
  THREE$AlwaysDepth,
  THREE$NeverDepth,
  THREE$SrcAlphaSaturateFactor,
  THREE$OneMinusDstColorFactor,
  THREE$DstColorFactor,
  THREE$OneMinusDstAlphaFactor,
  THREE$DstAlphaFactor,
  THREE$OneMinusSrcAlphaFactor,
  THREE$SrcAlphaFactor,
  THREE$OneMinusSrcColorFactor,
  THREE$SrcColorFactor,
  THREE$OneFactor,
  THREE$ZeroFactor,
  THREE$MaxEquation,
  THREE$MinEquation,
  THREE$ReverseSubtractEquation,
  THREE$SubtractEquation,
  THREE$AddEquation,
  THREE$CustomBlending,
  THREE$MultiplyBlending,
  THREE$SubtractiveBlending,
  THREE$AdditiveBlending,
  THREE$NormalBlending,
  THREE$NoBlending,
  THREE$VertexColors,
  THREE$FaceColors,
  THREE$NoColors,
  THREE$SmoothShading,
  THREE$FlatShading,
  THREE$NoShading,
  THREE$DoubleSide,
  THREE$BackSide,
  THREE$FrontSide,
  THREE$PCFSoftShadowMap,
  THREE$PCFShadowMap,
  THREE$BasicShadowMap,
  THREE$FrontFaceDirectionCCW,
  THREE$FrontFaceDirectionCW,
  THREE$CullFaceFrontBack,
  THREE$CullFaceFront,
  THREE$CullFaceBack,
  THREE$CullFaceNone,
  THREE$MOUSE
};