import { THREE$Object3D } from '../core/Object3D';
import { THREE$Light } from './Light';

/**
 * @author mrdoob / http://mrdoob.com/
 */

function THREE$PointLight ( color, intensity, distance, decay ) {
	this.isPointLight = true;

	THREE$Light.call( this, color );

	this.type = 'PointLight';

	this.intensity = ( intensity !== undefined ) ? intensity : 1;
	this.distance = ( distance !== undefined ) ? distance : 0;
	this.decay = ( decay !== undefined ) ? decay : 1;	// for physically correct lights, should be 2.

};

THREE$PointLight.prototype = Object.create( THREE$Light.prototype );
THREE$PointLight.prototype.constructor = THREE$PointLight;

THREE$PointLight.prototype.clone = function () {

	var light = new THREE$PointLight();

	THREE$Light.prototype.clone.call( this, light );

	light.intensity = this.intensity;
	light.distance = this.distance;
	light.decay = this.decay;

	return light;

};

THREE$PointLight.prototype.toJSON = function ( meta ) {

	var data = THREE$Object3D.prototype.toJSON.call( this, meta );

	data.object.color = this.color.getHex();
	data.object.intensity = this.intensity;
	data.object.distance = this.distance;
	data.object.decay = this.decay;

	return data;

};


export { THREE$PointLight };