import { THREE$Material } from './Material';

/**
 * @author mrdoob / http://mrdoob.com/
 *
 * parameters = {
 *  opacity: <float>,
 *
 *  shading: THREE.FlatShading,
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  wireframe: <boolean>,
 *  wireframeLinewidth: <float>
 * }
 */

function THREE$MeshNormalMaterial ( parameters ) {
	this.isMeshNormalMaterial = true;

	THREE$Material.call( this, parameters );

	this.type = 'MeshNormalMaterial';

	this.wireframe = false;
	this.wireframeLinewidth = 1;

	this.morphTargets = false;

	this.setValues( parameters );

};

THREE$MeshNormalMaterial.prototype = Object.create( THREE$Material.prototype );
THREE$MeshNormalMaterial.prototype.constructor = THREE$MeshNormalMaterial;

THREE$MeshNormalMaterial.prototype.clone = function () {

	var material = new THREE$MeshNormalMaterial();

	THREE$Material.prototype.clone.call( this, material );

	material.wireframe = this.wireframe;
	material.wireframeLinewidth = this.wireframeLinewidth;

	return material;

};


export { THREE$MeshNormalMaterial };